import {Complex} from './type.js'
import type {Dependencies, Signature} from '../interfaces/type.js'
import {$reflect} from '../interfaces/type.js'

export const isReal =
   <T>(dep: Dependencies<'add' | 'equal' | 'isReal', T>):
      Signature<'isReal', Complex<T>> =>
   z => dep.isReal(z.re) && dep.equal(z.re, dep.add(z.re, z.im))

export const isSquare = (): Signature<'isSquare', Complex<unknown>> =>
   z => true // FIXME: not correct for Complex<bigint> once we get there

$reflect!([isReal, isSquare])
